# -*- coding: utf-8 -*-
from os.path import dirname, join, isfile
from tornado.web import StaticFileHandler
from handlers import *
from libs import uiModules

## SqlAlchemy Connection:

# configurati il db
# 'sqlite:///relative_path_to_dbname.db'
# 'sqlite:////absolute/path/to/dbname.db'


here = dirname(__file__)
project_root = join(here, '..')

static_path = join(here, 'static')
template_path = join(here, 'templates')


sqla_uri = 'sqlite:///%s/data/inventory.db' % project_root
sqla_params = {
    'echo': False,
    'encoding': 'utf-8'
}

handlers = [
    (r'/', IndexHandler),
    (r'/buildings', BuildingHandler),
    (r'/departments', DepartmentHandler),
    (r'/racks', RackHandler),
    (r'/devices', DeviceHandler),
    (r'/users', UserHandler),
    (r'/s/.*', SearchHandler),
    (r'/get/(.*)', GetHandler),
    (r'/static/(.*)', StaticFileHandler),
    (r'/.*$', NoDestinationHandler)
    ]

settings = {
    'debug': isfile(join(project_root, 'debug')),
    'static_path': static_path,
    'ui_modules': uiModules,
    }

URL = "http://inventory.unipi.it/get/"
