#####################################################################
# department.py created 12 Luglio 2013
#
#####################################################################
#
# Copyright (C) 2013 Paolo De Rosa  <paolo.de.rosa@unipi.it>
#
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use,
# copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following
# conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.


from inventory.models import *


class Department(IBaseMixin, Base):
    __tablename__ = 'departments'
    id  = Column(String, primary_key=True)
    key = Column(Unicode, nullable=False)
    parent_id = None
    parent  =  None
    qrcode = Column(LargeBinary)

    # Custom attrs
    isp = Column(Unicode, nullable=False)
    name = Column(Unicode, nullable=False)
    address = Column(Unicode, nullable=False)
    domain = Column(Unicode, nullable=False)

    #jinja2 views of hiself 
    tmpl = "./objects/department.html"

    def __init__(self, key, name, address, isp, domain):
        self.key = key
        self.id = self.uuid
        self.qrcode = self._qrcode

        self.isp = isp
        self.name = name
        self.address = address
        self.domain = domain

