#####################################################################
# rack.py created 12 Luglio 2013
#
#####################################################################
#
# Copyright (C) 2013 Paolo De Rosa  <paolo.de.rosa@unipi.it>
#
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use,
# copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following
# conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

from inventory.models import *

class Rack(Base):
    __tablename__ = 'racks'

    id  = Column(String, primary_key=True)
    key = Column(String, primary_key=True)
    parent_id = Column(Integer, ForeignKey('buildings.id'))
    parent =  relationship("Building", backref=backref('racks', order_by=id))
    qrcode = Column(LargeBinary)

    # Object attrs
    floor = Column(Unicode, nullable=False)
    units = Column(Integer)

    def __init__(self, key, building, floor):
        self.key = key
        self.parent = building
        self.id = self.uuid
        self.qrcode = self._qrcode

        self.floor = floor
